tclap: TCLAP::MultiArg< T > Class Template Reference

# TCLAP::MultiArg< T > Class Template Reference

An argument that allows multiple values of type T to be specified. More...

`#include <MultiArg.h>`

Inheritance diagram for TCLAP::MultiArg< T >:

List of all members.

## Public Types
typedef std::vector< T > | container_type
typedef container_type::iterator | iterator
typedef container_type::const_iterator | const_iterator
## Public Member Functions
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, const std::string &typeDesc, Visitor *v=NULL)
| Constructor.
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, const std::string &typeDesc, CmdLineInterface &parser, Visitor *v=NULL)
| Constructor.
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, Constraint< T > *constraint, Visitor *v=NULL)
| Constructor.
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, Constraint< T > *constraint, CmdLineInterface &parser, Visitor *v=NULL)
| Constructor.
virtual bool | processArg (int *i, std::vector< std::string > &args)
| Handles the processing of the argument.
const std::vector< T > & | getValue ()
| Returns a vector of type T containing the values parsed from the command line.
const_iterator | begin () const
| Returns an iterator over the values parsed from the command line.
const_iterator | end () const
| Returns the end of the values parsed from the command line.
virtual std::string | shortID (const std::string &val="val") const
| Returns the a short id string.
virtual std::string | longID (const std::string &val="val") const
| Returns the a long id string.
virtual bool | isRequired () const
| Once we've matched the first value, then the arg is no longer required.
virtual bool | allowMore ()
| Used for MultiArgs and XorHandler to determine whether args can still be set.
virtual void | reset ()
| Clears the Arg object and allows it to be reused by new command lines.
## Protected Member Functions
void | _extractValue (const std::string &val)
| Extracts the value from the string.
## Protected Attributes
std::vector< T > | _values
| The list of values parsed from the CmdLine.
std::string | _typeDesc
| The description of type T to be used in the usage.
Constraint< T > * | _constraint
| A list of constraint on this Arg.
bool | _allowMore
| Used by XorHandler to decide whether to keep parsing for this arg.

## Detailed Description

### template<class T>
class TCLAP::MultiArg< T >

An argument that allows multiple values of type T to be specified.

Very similar to a ValueArg, except a vector of values will be returned instead of just one.

Definition at line 39 of file MultiArg.h.

## Member Typedef Documentation

template<class T>

typedef container_type::const_iterator TCLAP::MultiArg< T >::const_iterator

Definition at line 44 of file MultiArg.h.

template<class T>

typedef std::vector<T> TCLAP::MultiArg< T >::container_type

Definition at line 42 of file MultiArg.h.

template<class T>

typedef container_type::iterator TCLAP::MultiArg< T >::iterator

Definition at line 43 of file MultiArg.h.

## Constructor & Destructor Documentation

template<class T >

TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | const std::string & | typeDesc,
|  | Visitor * | v = `NULL` |
| ) |  |  | `[inline]`

Constructor.

Parameters:

  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 234 of file MultiArg.h.

References TCLAP::Arg::_acceptsMultipleValues.

template<class T >

TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | const std::string & | typeDesc,
|  | CmdLineInterface & | parser,
|  | Visitor * | v = `NULL` |
| ) |  |  | `[inline]`

Constructor.

Parameters:

  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  | parser | - A CmdLine parser object to add this Arg to
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 250 of file MultiArg.h.

References TCLAP::Arg::_acceptsMultipleValues, and TCLAP::CmdLineInterface::add().

template<class T >

TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | Constraint< T > * | constraint,
|  | Visitor * | v = `NULL` |
| ) |  |  | `[inline]`

Constructor.

Parameters:

  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | constraint | - A pointer to a Constraint object used to constrain this Arg.
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 271 of file MultiArg.h.

References TCLAP::Arg::_acceptsMultipleValues.

template<class T >

TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | Constraint< T > * | constraint,
|  | CmdLineInterface & | parser,
|  | Visitor * | v = `NULL` |
| ) |  |  | `[inline]`

Constructor.

Parameters:

  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | constraint | - A pointer to a Constraint object used to constrain this Arg.
  | parser | - A CmdLine parser object to add this Arg to
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 287 of file MultiArg.h.

References TCLAP::Arg::_acceptsMultipleValues, and TCLAP::CmdLineInterface::add().

## Member Function Documentation

template<class T >

void TCLAP::MultiArg< T >::_extractValue | ( | const std::string & | val | ) | `[inline, protected]`

Extracts the value from the string.

Attempts to parse string as type T, if this fails an exception is thrown.

Parameters:

  | val | - The string to be read.

Definition at line 398 of file MultiArg.h.

References TCLAP::MultiArg< T >::_constraint, TCLAP::MultiArg< T >::_values, TCLAP::ArgException::error(), TCLAP::ExtractValue(), and TCLAP::Arg::toString().

Referenced by TCLAP::UnlabeledMultiArg< T >::processArg(), and TCLAP::MultiArg< T >::processArg().

template<class T >

bool TCLAP::MultiArg< T >::allowMore | ( |  | ) | `[inline, virtual]`

Used for MultiArgs and XorHandler to determine whether args can still be set.

Reimplemented from TCLAP::Arg.

Definition at line 417 of file MultiArg.h.

References TCLAP::MultiArg< T >::_allowMore.

template<class T>

const_iterator TCLAP::MultiArg< T >::begin | ( |  | ) | const`[inline]`

Returns an iterator over the values parsed from the command line.

Definition at line 194 of file MultiArg.h.

References TCLAP::MultiArg< T >::_values.

template<class T>

const_iterator TCLAP::MultiArg< T >::end | ( |  | ) | const`[inline]`

Returns the end of the values parsed from the command line.

Definition at line 200 of file MultiArg.h.

References TCLAP::MultiArg< T >::_values.

template<class T >

const std::vector< T > & TCLAP::MultiArg< T >::getValue | ( |  | ) | `[inline]`

Returns a vector of type T containing the values parsed from the command line.

Definition at line 305 of file MultiArg.h.

References TCLAP::MultiArg< T >::_values.

template<class T >

bool TCLAP::MultiArg< T >::isRequired | ( |  | ) | const`[inline, virtual]`

Once we've matched the first value, then the arg is no longer required.

Reimplemented from TCLAP::Arg.

Definition at line 383 of file MultiArg.h.

References TCLAP::Arg::_required, and TCLAP::MultiArg< T >::_values.

template<class T >

std::string TCLAP::MultiArg< T >::longID | ( | const std::string & | val = `"val"` | ) | const`[inline, virtual]`

Returns the a long id string.

Used in the usage.

Parameters:

  | val | - value to be used.

Reimplemented from TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledMultiArg< T >.

Definition at line 372 of file MultiArg.h.

References TCLAP::MultiArg< T >::_typeDesc.

template<class T >

bool TCLAP::MultiArg< T >::processArg | ( | int * | i,
|  | std::vector< std::string > & | args |
| ) |  |  | `[inline, virtual]`

Handles the processing of the argument.

This re-implements the Arg version of this method to set the _value of the argument appropriately. It knows the difference between labeled and unlabeled.

Parameters:

  | i | - Pointer the the current argument in the list.
  | args | - Mutable list of strings. Passed from main().

Implements TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledMultiArg< T >.

Definition at line 308 of file MultiArg.h.

References TCLAP::Arg::_alreadySet, TCLAP::Arg::_checkWithVisitor(), TCLAP::MultiArg< T >::_extractValue(), TCLAP::Arg::_hasBlanks(), TCLAP::Arg::_ignoreable, TCLAP::Arg::argMatches(), TCLAP::Arg::delimiter(), TCLAP::Arg::ignoreRest(), TCLAP::Arg::toString(), and TCLAP::Arg::trimFlag().

template<class T >

void TCLAP::MultiArg< T >::reset | ( |  | ) | `[inline, virtual]`

Clears the Arg object and allows it to be reused by new command lines.

Reimplemented from TCLAP::Arg.

Definition at line 425 of file MultiArg.h.

References TCLAP::MultiArg< T >::_values.

template<class T >

std::string TCLAP::MultiArg< T >::shortID | ( | const std::string & | val = `"val"` | ) | const`[inline, virtual]`

Returns the a short id string.

Used in the usage.

Parameters:

  | val | - value to be used.

Reimplemented from TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledMultiArg< T >.

Definition at line 362 of file MultiArg.h.

References TCLAP::MultiArg< T >::_typeDesc.

## Member Data Documentation

template<class T>

bool TCLAP::MultiArg< T >::_allowMore`[protected]`

Used by XorHandler to decide whether to keep parsing for this arg.

Definition at line 74 of file MultiArg.h.

Referenced by TCLAP::MultiArg< T >::allowMore().

template<class T>

Constraint<T>* TCLAP::MultiArg< T >::_constraint`[protected]`

A list of constraint on this Arg.

Definition at line 61 of file MultiArg.h.

Referenced by TCLAP::MultiArg< T >::_extractValue().

template<class T>

std::string TCLAP::MultiArg< T >::_typeDesc`[protected]`

The description of type T to be used in the usage.

Definition at line 56 of file MultiArg.h.

Referenced by TCLAP::UnlabeledMultiArg< T >::longID(), TCLAP::MultiArg< T >::longID(), TCLAP::UnlabeledMultiArg< T >::shortID(), and TCLAP::MultiArg< T >::shortID().

template<class T>

std::vector<T> TCLAP::MultiArg< T >::_values`[protected]`

The list of values parsed from the CmdLine.

Definition at line 51 of file MultiArg.h.

Referenced by TCLAP::MultiArg< T >::_extractValue(), TCLAP::MultiArg< T >::begin(), TCLAP::MultiArg< T >::end(), TCLAP::MultiArg< T >::getValue(), TCLAP::MultiArg< T >::isRequired(), and TCLAP::MultiArg< T >::reset().

The documentation for this class was generated from the following file:

- MultiArg.h